//////////////////////////////////////////////////////////////////////////////////
//																				//
//		Roller																	//
//		Test and Demo of RollAPI library										//
//		Copyright (C),1998 SoftLab-Nsk											//
//																				//
//		Author:		Serge Horun													//
//																				//
//		Last revised(86C):		Dec 25, 1998, Serge Horun						//
//																				//
//////////////////////////////////////////////////////////////////////////////////

// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "RollAPI.h"
#include "RollBase.h"
#include "ViewA.h"
#include "Roller.h"
#include "DlgProxy.h"
#include "RollerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRollerDlgAutoProxy

IMPLEMENT_DYNCREATE(CRollerDlgAutoProxy, CCmdTarget)

CRollerDlgAutoProxy::CRollerDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CRollerDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CRollerDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CRollerDlgAutoProxy::~CRollerDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	AfxOleUnlockApp();
}

void CRollerDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CRollerDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CRollerDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CRollerDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CRollerDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IRoller to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {6B285548-8857-11D2-9E24-00804883698B}
static const IID IID_IRoller =
{ 0x6b285548, 0x8857, 0x11d2, { 0x9e, 0x24, 0x0, 0x80, 0x48, 0x83, 0x69, 0x8b } };

BEGIN_INTERFACE_MAP(CRollerDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CRollerDlgAutoProxy, IID_IRoller, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {6B285546-8857-11D2-9E24-00804883698B}
IMPLEMENT_OLECREATE2(CRollerDlgAutoProxy, "Roller.Application", 0x6b285546, 0x8857, 0x11d2, 0x9e, 0x24, 0x0, 0x80, 0x48, 0x83, 0x69, 0x8b)

/////////////////////////////////////////////////////////////////////////////
// CRollerDlgAutoProxy message handlers
