//////////////////////////////////////////////////////////////////////////////////
//																				//
//		Roller																	//
//		Test and Demo of RollAPI library										//
//		Copyright (C),1998 SoftLab-Nsk											//
//																				//
//		Author:		Serge Horun													//
//																				//
//		Last revised(86C):		Dec 25, 1998, Serge Horun						//
//																				//
//////////////////////////////////////////////////////////////////////////////////

// DurationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Roller.h"
#include "DurationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDurationDlg dialog


CDurationDlg::CDurationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDurationDlg::IDD, pParent)
{
	EnableAutomation();

	//{{AFX_DATA_INIT(CDurationDlg)
	m_Duration = 0;
	//}}AFX_DATA_INIT
}

void CDurationDlg::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CDurationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDurationDlg)
	DDX_Text(pDX, IDC_DURATION_EDIT, m_Duration);
	DDV_MinMaxLong(pDX, m_Duration, 1, 30000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDurationDlg, CDialog)
	//{{AFX_MSG_MAP(CDurationDlg)
	ON_BN_CLICKED(IDC_RADIO_FINITE, OnRadioFinite)
	ON_BN_CLICKED(IDC_RADIO_INFINITE, OnRadioInfinite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDurationDlg, CDialog)
	//{{AFX_DISPATCH_MAP(CDurationDlg)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDurationDlg to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {AC6A53E1-982F-11D2-BD89-000001137736}
static const IID IID_IDurationDlg =
{ 0xac6a53e1, 0x982f, 0x11d2, { 0xbd, 0x89, 0x0, 0x0, 0x1, 0x13, 0x77, 0x36 } };

BEGIN_INTERFACE_MAP(CDurationDlg, CDialog)
	INTERFACE_PART(CDurationDlg, IID_IDurationDlg, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDurationDlg message handlers

BOOL CDurationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if(m_Infinite)
	{
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_INFINITE))->SetCheck(1);

		GetDlgItem(IDC_DURATION_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_DURATION_EDIT)->SetWindowText("1");
		GetDlgItem(IDC_SPIN_DURATION)->EnableWindow(FALSE);
		static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_SPIN_DURATION))->SetPos(1);
	}
	else
	{
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_FINITE))->SetCheck(1);
		static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_SPIN_DURATION))->SetPos((int)m_Duration);
	}
	static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_SPIN_DURATION))->SetRange(1, 30000);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDurationDlg::OnRadioFinite() 
{
	GetDlgItem(IDC_DURATION_EDIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_SPIN_DURATION)->EnableWindow(TRUE);
	m_Infinite = false;
}

void CDurationDlg::OnRadioInfinite() 
{
	GetDlgItem(IDC_DURATION_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_SPIN_DURATION)->EnableWindow(FALSE);
	m_Infinite = true;
}
