//////////////////////////////////////////////////////////////////////////////////
//																				//
//		Roller																	//
//		Test and Demo of RollAPI library										//
//		Copyright (C),1998 SoftLab-Nsk											//
//																				//
//		Author:		Serge Horun													//
//																				//
//		Last revised(86C):		Dec 25, 1998, Serge Horun						//
//																				//
//////////////////////////////////////////////////////////////////////////////////

// RegionDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RollAPI.h"
#include "RollBase.h"
#include "Roller.h"
#include "ViewA.h"
#include "RegionDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegionDialog dialog


CRegionDialog::CRegionDialog(CString name, CViewA * pView, CWnd* pParent /*=NULL*/)
	: CDialog(CRegionDialog::IDD, pParent), m_Name(name)
{
	ASSERT(pView);
	m_pView = pView;
	EnableAutomation();

	//{{AFX_DATA_INIT(CRegionDialog)
	m_Left = 0;
	m_Top = 0;
	m_ScreenSize = _T("");
	m_Height = 0;
	m_Width = 0;
	//}}AFX_DATA_INIT
}


void CRegionDialog::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CRegionDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegionDialog)
	DDX_Text(pDX, IDC_REGION_LEFT, m_Left);
	DDX_Text(pDX, IDC_REGION_TOP, m_Top);
	DDX_Text(pDX, IDC_SCREEN_SIZE, m_ScreenSize);
	DDX_Text(pDX, IDC_REGION_HEIGHT, m_Height);
	DDV_MinMaxInt(pDX, m_Height, 1, 32000);
	DDX_Text(pDX, IDC_REGION_WIDTH, m_Width);
	DDV_MinMaxInt(pDX, m_Width, 1, 32000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRegionDialog, CDialog)
	//{{AFX_MSG_MAP(CRegionDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CRegionDialog, CDialog)
	//{{AFX_DISPATCH_MAP(CRegionDialog)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IRegionDialog to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {982BA6E4-900B-11D2-ADD7-008048837019}
static const IID IID_IRegionDialog =
{ 0x982ba6e4, 0x900b, 0x11d2, { 0xad, 0xd7, 0x0, 0x80, 0x48, 0x83, 0x70, 0x19 } };

BEGIN_INTERFACE_MAP(CRegionDialog, CDialog)
	INTERFACE_PART(CRegionDialog, IID_IRegionDialog, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegionDialog message handlers

#define __swapi(a, b) {int tmp = a; a = b; b = tmp;}
void CRegionDialog::OnOK() 
{
	if(!UpdateData(TRUE))
	{
		TRACE0("UpdateData failed during dialog termination.\n");
		return;
	}
	if(!((m_Left >= 0) && (m_Left <= m_MaxX)) || !((m_Left+m_Width >= 0) && (m_Left+m_Width <= m_MaxX))
		|| !((m_Top >= 0) && (m_Top <= m_MaxY)) || !((m_Top+m_Height >= 0) && (m_Top+m_Height <= m_MaxY)))
	{
		if(AfxMessageBox("Cannot place region to this rectangle because it does not fit the screen.\n\nDo you want to change coordinates?", MB_YESNO) != IDYES)
			EndDialog(IDCANCEL);
		return;
	}
	CRect rect(m_Left, m_Top, m_Left+m_Width, m_Top+m_Height);
	if(TestIntersection(rect, m_pView->m_pCurrent) != NULL)
	{
		if(AfxMessageBox("Cannot place region to this rectangle because some part of it already occupied.\n\nDo you want to change coordinates?", MB_YESNO) != IDYES)
			EndDialog(IDCANCEL);
		return;
	}
	EndDialog(IDOK);
}

BOOL CRegionDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText(m_Name);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
