/*  Project ddclip32
    FIRM:   SoftLab
    AUTHOR: IMA,Egor

    OVERVIEW
    ========
    Source file for initializing RollAPI DLL functions.
*/

#include "stdafx.h"

#define ROLLAPI_CPP

#include "rollapi.h"

static HINSTANCE hdll = NULL;

ImageHandle WINAPI DummyRollAPI_MakeImage(BITMAPINFOHEADER*,void*)
{ return NULL; }
ImageHandle WINAPI DummyRollAPI_ComposeImage(int,int,int,POINT[],ImageHandle[],RECT[])
{ return NULL; }
long WINAPI DummyRollAPI_DeleteImage(ImageHandle)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetImageData(ImageHandle,int,int,long*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_SetImageData(ImageHandle,int,int,long*)
{ return RollAPI_ErrNoHardware; }
ScreenHandle WINAPI DummyRollAPI_AllocateScreen(RECT*,long)
{ return NULL; }
long WINAPI DummyRollAPI_ReleaseScreen(ScreenHandle)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetFrameRate(double *lpFrameRate) {
  if( lpFrameRate )  *lpFrameRate = 25.0;
  return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetScreenSize(ScreenHandle, RECT *lpRect) {
  if( lpRect ) { lpRect->left=lpRect->top=0;  lpRect->right=720;  lpRect->bottom=576; }
  return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_ShowImage(ScreenHandle,ImageHandle,POINT*,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_PutImage(ScreenHandle,ImageHandle,POINT*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_ClearArea(ScreenHandle,RECT*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_ShowScreen(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_PrepareScreenPlayback(ScreenHandle)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_PrepareScreenPlayback2(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_StartScreenPlayback(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_PauseScreenPlayback(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_UnpauseScreenPlayback(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_StopScreenPlayback(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_WaitStopScreenPlayback(ScreenHandle,long)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetCurrentFrame(ScreenHandle,int*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetWorkingFrame(ScreenHandle,int*)
{ return RollAPI_ErrNoHardware; }
RegionHandle WINAPI DummyRollAPI_AllocateRegion(ScreenHandle,RECT*,
                       double,double,long,int,ImageHandle[],long[])
{ return NULL; }
long WINAPI DummyRollAPI_ReleaseRegion(ScreenHandle,RegionHandle)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_SetRegionSpeedScale(RegionHandle,double)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetRegionPosition(ScreenHandle,RegionHandle,RECT*,int*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetPreparedRegionPosition(ScreenHandle,RegionHandle,RECT*,int*)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_GetLastError(void)
{ return RollAPI_ErrNoHardware; }
long WINAPI DummyRollAPI_SetRegionCallback(RegionHandle,RollAPICallbackProc,void*)
{ return RollAPI_ErrNoHardware; }

static BOOL GetAddress(FARPROC *paddr, LPSTR name, FARPROC dummy)
{
  if( hdll )  *paddr = GetProcAddress(hdll,name);
  else  *paddr = 0;
  if( *paddr==0 ) {
    *paddr = dummy;
    return FALSE;
  }
  return TRUE;
}

#define GetAddr(name) \
if( !GetAddress((FARPROC*)&name,#name,(FARPROC)Dummy##name) )  res = FALSE;

static BOOL FillAddresses()
{
  BOOL res = TRUE;
  GetAddr(RollAPI_MakeImage)
  GetAddr(RollAPI_ComposeImage)
  GetAddr(RollAPI_DeleteImage)
  GetAddr(RollAPI_GetImageData)
  GetAddr(RollAPI_SetImageData)
  GetAddr(RollAPI_AllocateScreen)
  GetAddr(RollAPI_ReleaseScreen)
  GetAddr(RollAPI_GetFrameRate)
  GetAddr(RollAPI_GetScreenSize)
  GetAddr(RollAPI_ShowImage)
  GetAddr(RollAPI_PutImage)
  GetAddr(RollAPI_ClearArea)
  GetAddr(RollAPI_ShowScreen)
  GetAddr(RollAPI_PrepareScreenPlayback)
  GetAddr(RollAPI_PrepareScreenPlayback2)
  GetAddr(RollAPI_StartScreenPlayback)
  GetAddr(RollAPI_PauseScreenPlayback)
  GetAddr(RollAPI_UnpauseScreenPlayback)
  GetAddr(RollAPI_StopScreenPlayback)
  GetAddr(RollAPI_WaitStopScreenPlayback)
  GetAddr(RollAPI_GetCurrentFrame)
  GetAddr(RollAPI_GetWorkingFrame)
  GetAddr(RollAPI_AllocateRegion)
  GetAddr(RollAPI_ReleaseRegion)
  GetAddr(RollAPI_SetRegionSpeedScale)
  GetAddr(RollAPI_GetRegionPosition)
  GetAddr(RollAPI_GetPreparedRegionPosition)
  GetAddr(RollAPI_SetRegionCallback)
  GetAddr(RollAPI_GetLastError)
  return res;
}

void Exit_RollAPI()
{
  if( hdll ) { FreeLibrary(hdll);  hdll=NULL; }
  FillAddresses();
}

BOOL Init_RollAPI()
{
  if( hdll )  return TRUE;
  hdll = LoadLibrary("ROLLAPI.DLL");
  if( FillAddresses() )  return TRUE;
  Exit_RollAPI();
  return FALSE;
}


// init all
class InitRollAPIClass {
  public:
    InitRollAPIClass() { Init_RollAPI(); }
    ~InitRollAPIClass() { Exit_RollAPI(); }
};
static InitRollAPIClass initializator;
