//////////////////////////////////////////////////////////////////////////////////
//																				//
//		Roller																	//
//		Test and Demo of RollAPI library										//
//		Copyright (C),1998 SoftLab-Nsk											//
//																				//
//		Author:		Serge Horun													//
//																				//
//		Last revised(86C):		Dec 25, 1998, Serge Horun						//
//																				//
//////////////////////////////////////////////////////////////////////////////////

// RollerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rollapi.h"
#include "rollbase.h"
#include "ViewA.h"
#include "Roller.h"
#include "RollerDlg.h"
#include "DlgProxy.h"
#include "LengthDlg.h"
#include "DurationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ClientBottomSubst 75
#define ClientViewBottomSubst 75
#define ClientLeftAdd 20
#define ClientTopAdd 20
#define ClientListTopAdd 25
#define ClientRightSubst 12
#define ClientListRightSubst 135
#define ClientViewRightSubst (ClientListRightSubst + 150)

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRollerDlg dialog

IMPLEMENT_DYNAMIC(CRollerDlg, CDialog);

CRollerDlg::CRollerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRollerDlg::IDD, pParent), m_FileList(), m_wndView(), m_Menu()
{
	//{{AFX_DATA_INIT(CRollerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	m_Modified = false;
	m_hScreen = NULL;
}

CRollerDlg::~CRollerDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CRollerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRollerDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRollerDlg, CDialog)
	//{{AFX_MSG_MAP(CRollerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_COMMAND(IDC_UPDATE_REG_INFO, OnUpdateRegInfo)
	ON_BN_CLICKED(IDC_RADIO_HSCROLL, OnRadioClicked)
	ON_EN_CHANGE(IDC_SPEED_EDIT, OnSelchangeSpeedEdit)
	ON_WM_RBUTTONDOWN()
	ON_WM_PARENTNOTIFY()
	ON_COMMAND(ID_ADD_FILE, OnAddFile)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_COMMAND(ID_REMOVE_FILE, OnRemoveFile)
	ON_UPDATE_COMMAND_UI(ID_REMOVE_FILE, OnImageNameClicked)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MOVE_UP, OnMoveUp)
	ON_COMMAND(ID_MOVE_DOWN, OnMoveDown)
	ON_COMMAND(IDC_ADD_EMPTY, OnAddEmpty)
	ON_COMMAND(IDC_EDIT_EMPTY, OnEditEmpty)
	ON_LBN_SELCHANGE(IDC_FILE_LIST, OnSelChangeFileView)
	ON_LBN_DBLCLK(IDC_FILE_LIST, OnDblClkFileView)
 	ON_CBN_SELCHANGE(IDC_PRECISION_COMBO, OnSelchangePrecisionCombo)
	ON_EN_CHANGE(IDC_REPEAT_COUNTER, OnChangeRepeatCounter)
	ON_CBN_SELCHANGE(IDC_BANK, OnSelchangeBank)
	ON_COMMAND(IDC_EDIT_DURATION, OnEditDuration)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_RADIO_STATIC, OnRadioClicked)
	ON_BN_CLICKED(IDC_RADIO_VSCROLL, OnRadioClicked)
	ON_UPDATE_COMMAND_UI(ID_MOVE_UP, OnImageNameClicked)
	ON_UPDATE_COMMAND_UI(ID_MOVE_DOWN, OnImageNameClicked)
	ON_BN_CLICKED(IDC_RADIO_ANIM, OnRadioClicked)
	ON_BN_CLICKED(IDC_CONTINUE, OnContinue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRollerDlg message handlers

BOOL CRollerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitScreenInfo();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CRect rect;
	GetClientRect(&rect);
	m_FileList.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP | WS_BORDER
		| LBS_OWNERDRAWFIXED | LBS_HASSTRINGS | LBS_USETABSTOPS | LBS_NOINTEGRALHEIGHT | LBS_NOTIFY, //| LBS_EXTENDEDSEL
		CRect(rect.right - ClientListRightSubst, rect.top + ClientListTopAdd, 
		rect.right - ClientRightSubst, rect.bottom - ClientBottomSubst), this, IDC_FILE_LIST);
	m_rcView = CRect(rect.left + ClientLeftAdd, rect.top + ClientTopAdd,
		rect.right - ClientViewRightSubst, rect.bottom - ClientViewBottomSubst);
	if(!m_wndView.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER, m_rcView, this, IDC_VIEW))
		return FALSE;
	static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_SPEED_SPIN))->SetRange(-1500, 1500);
	static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_REPEAT_SPIN))->SetRange(1, 1500);
	OnUpdateRegInfo();
	static_cast<CComboBox*>(GetDlgItem(IDC_BANK))->SetCurSel(g_DefaultBank);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRollerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CRollerDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRollerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		CPaintDC dc(this); // device context for painting

//		CBrush * p_br_old = static_cast<CBrush*>(m_MemDC.SelectStockObject(NULL_BRUSH));
//		CPen * p_pen_old = static_cast<CPen*>(m_MemDC.SelectStockObject(NULL_PEN));
		dc.FillSolidRect(&m_rcView, RGB(0, 0, 0));

	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRollerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CRollerDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CRollerDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CRollerDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CRollerDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CRollerDlg::OnUpdateRegInfo() 
{
	TRACE("Update reg info\n");
	if(m_wndView.m_pCurrent == NULL)
	{
		GetDlgItem(IDC_RADIO_STATIC)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_ANIM)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_HSCROLL)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_VSCROLL)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_A)->EnableWindow(FALSE);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_STATIC))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_ANIM))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_HSCROLL))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_VSCROLL))->SetCheck(0);
	}
	else
	{
		GetDlgItem(IDC_RADIO_STATIC)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_ANIM)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_HSCROLL)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_VSCROLL)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_A)->EnableWindow(TRUE);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_STATIC))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_ANIM))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_HSCROLL))->SetCheck(0);
		static_cast<CButton*>(GetDlgItem(IDC_RADIO_VSCROLL))->SetCheck(0);
		switch(m_wndView.m_pCurrent->m_Type)
		{
		case CRegionA::RT_STATIC :
			static_cast<CButton*>(GetDlgItem(IDC_RADIO_STATIC))->SetCheck(1);
			break;
		case CRegionA::RT_ANIMATED :
			static_cast<CButton*>(GetDlgItem(IDC_RADIO_ANIM))->SetCheck(1);
			break;
		case CRegionA::RT_HSCROLL :
			static_cast<CButton*>(GetDlgItem(IDC_RADIO_HSCROLL))->SetCheck(1);
			break;
		case CRegionA::RT_VSCROLL :
			static_cast<CButton*>(GetDlgItem(IDC_RADIO_VSCROLL))->SetCheck(1);
			break;
		}
	}
	UpdateSpeedInfo();
	UpdateFileList();
}

void CRollerDlg::UpdateSpeedInfo()
{
	if((m_wndView.m_pCurrent != NULL) && 
		((m_wndView.m_pCurrent->m_Type == CRegionA::RT_HSCROLL) 
		|| (m_wndView.m_pCurrent->m_Type == CRegionA::RT_VSCROLL)))
	{
		CString str;
		GetDlgItem(IDC_STATIC_B)->EnableWindow(TRUE);
		GetDlgItem(IDC_SPEED_EDIT)->EnableWindow(TRUE);
		str.Format("%f", m_wndView.m_pCurrent->m_ScrollSpeed);
		GetDlgItem(IDC_SPEED_EDIT)->SetWindowText(str);
		GetDlgItem(IDC_SPEED_SPIN)->EnableWindow(TRUE);
		static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_SPEED_SPIN))->SetPos((int)m_wndView.m_pCurrent->m_ScrollSpeed);

		GetDlgItem(IDC_STATIC_PREC)->EnableWindow(TRUE);
		GetDlgItem(IDC_PRECISION_COMBO)->EnableWindow(TRUE);
		static_cast<CComboBox*>(GetDlgItem(IDC_PRECISION_COMBO))->SetCurSel(m_wndView.m_pCurrent->m_Precision);

		GetDlgItem(IDC_STATIC_REP)->EnableWindow(TRUE);
		GetDlgItem(IDC_REPEAT_COUNTER)->EnableWindow(TRUE);
		str.Format("%d", m_wndView.m_pCurrent->m_cRepeat);
		GetDlgItem(IDC_REPEAT_COUNTER)->SetWindowText(str);
		GetDlgItem(IDC_REPEAT_SPIN)->EnableWindow(TRUE);
		static_cast<CSpinButtonCtrl*>(GetDlgItem(IDC_REPEAT_SPIN))->SetPos((int)m_wndView.m_pCurrent->m_cRepeat);
	}
	else
	{
		GetDlgItem(IDC_STATIC_B)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPEED_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPEED_EDIT)->SetWindowText("");
		GetDlgItem(IDC_SPEED_SPIN)->EnableWindow(FALSE);

		GetDlgItem(IDC_STATIC_PREC)->EnableWindow(FALSE);
		GetDlgItem(IDC_PRECISION_COMBO)->EnableWindow(FALSE);
		static_cast<CComboBox*>(GetDlgItem(IDC_PRECISION_COMBO))->SetCurSel(-1);

		GetDlgItem(IDC_STATIC_REP)->EnableWindow(FALSE);
		GetDlgItem(IDC_REPEAT_COUNTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_REPEAT_COUNTER)->SetWindowText("");
		GetDlgItem(IDC_REPEAT_SPIN)->EnableWindow(FALSE);
	}
}

void CRollerDlg::OnRadioClicked() 
{
	ASSERT(m_wndView.m_pCurrent);
	if(static_cast<CButton*>(GetDlgItem(IDC_RADIO_STATIC))->GetCheck() == 1)
		m_wndView.m_pCurrent->m_Type = CRegionA::RT_STATIC;
	else if(static_cast<CButton*>(GetDlgItem(IDC_RADIO_ANIM))->GetCheck() == 1)
		m_wndView.m_pCurrent->m_Type = CRegionA::RT_ANIMATED;
	else if(static_cast<CButton*>(GetDlgItem(IDC_RADIO_HSCROLL))->GetCheck() == 1)
		m_wndView.m_pCurrent->m_Type = CRegionA::RT_HSCROLL;
	else if(static_cast<CButton*>(GetDlgItem(IDC_RADIO_VSCROLL))->GetCheck() == 1)
		m_wndView.m_pCurrent->m_Type = CRegionA::RT_VSCROLL;
	else
		ASSERT(0);
	UpdateSpeedInfo();
	UpdateFileList();
}

void CRollerDlg::OnSelchangeSpeedEdit() 
{
	if(m_wndView.m_pCurrent != NULL)
	{
		CString str;
		CEdit* pEdit = static_cast<CEdit*>(GetDlgItem(IDC_SPEED_EDIT));
		ASSERT(pEdit);
		pEdit->GetWindowText(str);
		if(str != "")
		{
			float speed;
			sscanf(str, "%f", &speed);
			if(speed > 1500.0)
				speed = 1500.0;
			else if(speed < -1500.0)
				speed = -1500.0;
			m_wndView.m_pCurrent->m_ScrollSpeed = speed;
		}
	}
}

void CRollerDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
/*	CRect rc;
	m_FileList.GetWindowRect(&rc);
	ScreenToClient(&rc);
	if(rc.PtInRect(point))
	{
		m_Menu.LoadMenu(IDR_MENU_FILELIST2);
		CMenu *pSubMenu = m_Menu.GetSubMenu(0);
		ClientToScreen(&point);
		pSubMenu->TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, this);
		m_Menu.DestroyMenu();
		return;
	}
*/	
	CDialog::OnRButtonDown(nFlags, point);
}

CImageA * CRollerDlg::GetItem()
{
	CPoint pt;
	::GetCursorPos(&pt);
	TRACE("GetItem: init point: %d %d\n", pt.x, pt.y);
	CRect rc;
	m_FileList.GetWindowRect(&rc);
	pt -= rc.TopLeft();
	TRACE("GetItem: recalc point: %d %d\n", pt.x, pt.y);
	POSITION pos = m_wndView.m_pCurrent->m_plImages.GetHeadPosition();
	while(pos != NULL)
	{
		CImageA * pImg = m_wndView.m_pCurrent->m_plImages.GetNext(pos);
		int err = m_FileList.GetItemRect(pImg->m_CtrlIndex, &rc);
		TRACE("GetItem scan item, err code: %d %d %d %d, %d\n", rc.left, rc.top, rc.right, rc.bottom, err);
		if((err != LB_ERR) && rc.PtInRect(pt))
		{
			TRACE("GetItem last item hit succesfull!\n");
			return pImg;
		}
	}
	TRACE("GetItem no item found\n");
	return NULL;
}

void CRollerDlg::OnParentNotify(UINT message, LPARAM lParam) 
{
	CDialog::OnParentNotify(message, lParam);

	CPoint point;
	point.x = LOWORD(lParam);
	point.y = HIWORD(lParam);
	CRect rc;
	m_FileList.GetWindowRect(&rc);
	ScreenToClient(&rc);
	if(rc.PtInRect(point))
		m_FileList.SetFocus();

	if(message == WM_RBUTTONDOWN)
	{
		CPoint point;
		point.x = LOWORD(lParam);
		point.y = HIWORD(lParam);
		CRect rc;
		m_FileList.GetWindowRect(&rc);
		ScreenToClient(&rc);
		if(rc.PtInRect(point))
		{
			m_pImgClickOn = GetItem();
#ifdef _DEBUG
			if(m_pImgClickOn) 
				TRACE("Clicked on %s\n", (LPCTSTR)m_pImgClickOn->m_pDesc->m_strName);
			else
				TRACE("Clicked on nothing\n");
#endif
			if(m_pImgClickOn != NULL)
				m_FileList.SetCurSel(m_pImgClickOn->m_CtrlIndex);
			m_Menu.LoadMenu(IDR_MENU_POPUP);
			CMenu *pSubMenu = m_Menu.GetSubMenu(0);
			UINT todo = MF_BYCOMMAND | ((m_pImgClickOn != NULL)?MF_ENABLED:MF_GRAYED);
			pSubMenu->EnableMenuItem(ID_REMOVE_FILE, todo);
			if((m_pImgClickOn == NULL) || (m_wndView.m_pCurrent->m_plImages.IsEmpty()))
			{
				pSubMenu->EnableMenuItem(ID_MOVE_UP, MF_BYCOMMAND | MF_GRAYED);
				pSubMenu->EnableMenuItem(ID_MOVE_DOWN, MF_BYCOMMAND | MF_GRAYED);
			}
			else
			{
				pSubMenu->EnableMenuItem(ID_MOVE_UP, MF_BYCOMMAND | (((m_pImgClickOn != NULL) && (m_wndView.m_pCurrent->m_plImages.GetHead() != m_pImgClickOn))?MF_ENABLED:MF_GRAYED));
				pSubMenu->EnableMenuItem(ID_MOVE_DOWN, MF_BYCOMMAND | (((m_pImgClickOn != NULL) && (m_wndView.m_pCurrent->m_plImages.GetTail() != m_pImgClickOn))?MF_ENABLED:MF_GRAYED));
			}
			pSubMenu->EnableMenuItem(IDC_EDIT_EMPTY, MF_BYCOMMAND | (((m_pImgClickOn != NULL) && m_pImgClickOn->m_pDesc->m_Empty)?MF_ENABLED:MF_GRAYED));
			pSubMenu->EnableMenuItem(IDC_EDIT_DURATION, MF_BYCOMMAND | (((m_pImgClickOn != NULL) && (m_wndView.m_pCurrent != NULL) && (m_wndView.m_pCurrent->m_Type == CRegionA::RT_ANIMATED))?MF_ENABLED:MF_GRAYED));
			ClientToScreen(&point);
			pSubMenu->TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, this);
			m_Menu.DestroyMenu();
			return;
		}
	} 
	else if(message == WM_LBUTTONDOWN)
	{
/*		if(m_wndView.m_pCurrent != NULL)
		{
			CImageA * pImg = m_wndView.m_pCurrent->m_pImage;
			while(pImg != NULL)
			{
				pImg->m_Enabled = (m_FileList.GetCheck(pImg->m_CtrlIndex) == 1)?true: false;
				pImg = pImg->m_pNext;
			}
		}
*/	}
}

#define file_name_buf_length 2048
void CRollerDlg::OnAddFile() 
{
	ASSERT(m_wndView.m_pCurrent);
//	char* name_buffer = new char[file_name_buf_length];// 
	CFileDialog Dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Bitmap files (*.bmp)|*.bmp|All Files (*.*)|*.*||", this);
	Dlg.m_ofn.Flags |= OFN_ALLOWMULTISELECT;
//	Dlg.m_ofn.lpstrFile = name_buffer;
//	Dlg.m_ofn.nMaxFile = file_name_buf_length;
	if(Dlg.DoModal() == IDOK)
	{
		CImageA * pImg = NULL;
		POSITION pos = m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn);
		try
		{
			CString strName;
			POSITION pos = Dlg.GetStartPosition();
			while(pos != NULL)
			{
				strName = Dlg.GetNextPathName(pos);

				pImg = CreateImage(strName);
				if(pImg == NULL)
				{
					AfxMessageBox("File read error");
					continue;
				}

				if(m_pImgClickOn == NULL)
					m_wndView.m_pCurrent->m_plImages.AddTail(pImg);
				else
					m_wndView.m_pCurrent->m_plImages.InsertBefore(m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn), pImg);
			}

			UpdateFileList();
		}
		catch(...)
		{
			AfxMessageBox("File read error.");
		}
	}
//	delete name_buffer;
}

void CRollerDlg::UpdateFileList()
{
	m_FileList.ResetContent();
	if(m_wndView.m_pCurrent == NULL)
	{
		m_FileList.EnableWindow(FALSE);
	}
	else
	{
		m_FileList.EnableWindow(TRUE);
		POSITION pos = m_wndView.m_pCurrent->m_plImages.GetHeadPosition();
		while(pos != NULL)
		{
			CImageA * pImg = m_wndView.m_pCurrent->m_plImages.GetNext(pos);
			CString str = pImg->m_pDesc->m_strName.Right(pImg->m_pDesc->m_strName.GetLength() - pImg->m_pDesc->m_strName.ReverseFind('\\') - 1); 
			if(m_wndView.m_pCurrent->m_Type == CRegionA::RT_ANIMATED)
			{
				if(pImg->m_cDuration != -1)
				{
					CString s2;
					s2.Format("(%d)", pImg->m_cDuration);
					str += s2;
				}
				else
					str += "(inf)";
			}
			pImg->m_CtrlIndex = m_FileList.AddString(str);
			m_FileList.SetCheck(pImg->m_CtrlIndex, (pImg->m_Enabled)?1:0);
			m_FileList.SetItemData(pImg->m_CtrlIndex, (DWORD)pImg);
		}
	}
	m_pImgClickOn = NULL;
}

void CRollerDlg::OnPlay() 
{
	StartPlayback(m_hScreen);
}

void CRollerDlg::OnStop() 
{
	StopPlayback(m_hScreen);
}

void CRollerDlg::OnRemoveFile() 
{
	if(m_pImgClickOn != NULL)
	{
		m_wndView.m_pCurrent->m_plImages.RemoveAt(m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn));
		DestroyImage(m_pImgClickOn);
		UpdateFileList();
	}
}

void CRollerDlg::OnImageNameClicked(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pImgClickOn != NULL);
}

void CRollerDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
}

void CRollerDlg::OnMoveUp() 
{
	ASSERT(m_pImgClickOn);
	ASSERT(m_wndView.m_pCurrent);
	POSITION pos = m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn);
	ASSERT(pos);
	POSITION prev = pos;
	m_wndView.m_pCurrent->m_plImages.GetPrev(prev);
	ASSERT(prev);
	m_wndView.m_pCurrent->m_plImages.RemoveAt(pos);
	m_wndView.m_pCurrent->m_plImages.InsertBefore(prev, m_pImgClickOn);
	CImageA * pIClk = m_pImgClickOn;
	UpdateFileList();
	m_FileList.SetCurSel(pIClk->m_CtrlIndex);
}

void CRollerDlg::OnMoveDown() 
{
	ASSERT(m_pImgClickOn);
	ASSERT(m_wndView.m_pCurrent);
	POSITION pos = m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn);
	ASSERT(pos);
	POSITION next = pos;
	m_wndView.m_pCurrent->m_plImages.GetNext(next);
	ASSERT(next);
	m_wndView.m_pCurrent->m_plImages.RemoveAt(pos);
	m_wndView.m_pCurrent->m_plImages.InsertAfter(next, m_pImgClickOn);
	CImageA * pIClk = m_pImgClickOn;
	UpdateFileList();
	m_FileList.SetCurSel(pIClk->m_CtrlIndex);
}

void CRollerDlg::OnAddEmpty() 
{
	ASSERT(m_wndView.m_pCurrent);
	LengthDlg dlg;
	if(m_wndView.m_pCurrent->m_Type == CRegionA::RT_HSCROLL)
	{
		dlg.m_Length = m_wndView.m_pCurrent->m_Rect.Width();
		dlg.m_strRegionSize.Format("Width of current region: %d pixels", 
			m_wndView.m_pCurrent->m_Rect.Width());
	}
	else if(m_wndView.m_pCurrent->m_Type == CRegionA::RT_VSCROLL)
	{
		dlg.m_Length = m_wndView.m_pCurrent->m_Rect.Height();
		dlg.m_strRegionSize.Format("Height of current region: %d pixels", 
			m_wndView.m_pCurrent->m_Rect.Height());
	}
	else
	{
		dlg.m_Length = 100; 
		dlg.m_strRegionSize.Format("Size of current region: %dx%d pixels", 
			m_wndView.m_pCurrent->m_Rect.Width(),
			m_wndView.m_pCurrent->m_Rect.Height());
	}
	dlg.m_Name = "Insert Empty Space";
	if(dlg.DoModal() == IDOK)
	{
		CImageA * pImg = NULL;
		try
		{
			pImg = CreateEmptyImage(dlg.m_Length);

			if(m_pImgClickOn  == NULL)
				m_wndView.m_pCurrent->m_plImages.AddTail(pImg);
			else
				m_wndView.m_pCurrent->m_plImages.InsertBefore(m_wndView.m_pCurrent->m_plImages.Find(m_pImgClickOn), pImg);
			UpdateFileList();
		}
		catch(...)
		{
			AfxMessageBox("OOps. Memory allocation error.\n\nBetter quit.");
		}
	}
}

void CRollerDlg::OnEditEmpty() 
{
	ASSERT(m_wndView.m_pCurrent);
	ASSERT(m_pImgClickOn);
	ASSERT(m_pImgClickOn->m_pDesc->m_Empty);
	LengthDlg dlg;
	if(m_wndView.m_pCurrent->m_Type == CRegionA.RT_HSCROLL)
	{
		dlg.m_strRegionSize.Format("Width of current region: %d pixels", 
			m_wndView.m_pCurrent->m_Rect.Width());
	}
	else if(m_wndView.m_pCurrent->m_Type == CRegionA::RT_VSCROLL)
	{
		dlg.m_strRegionSize.Format("Height of current region: %d pixels", 
			m_wndView.m_pCurrent->m_Rect.Height());
	}
	else
	{
		dlg.m_strRegionSize.Format("Size of current region: %dx%d pixels", 
			m_wndView.m_pCurrent->m_Rect.Width(),
			m_wndView.m_pCurrent->m_Rect.Height());
	}
	dlg.m_Length = m_pImgClickOn->m_pDesc->m_Size.cx;
	dlg.m_Name = "Edit Empty Space";
	if(dlg.DoModal() == IDOK)
	{
		m_pImgClickOn->m_pDesc->m_strName.Format("Empty %d pixels", dlg.m_Length);
		m_pImgClickOn->m_pDesc->m_Size = CSize(dlg.m_Length, dlg.m_Length);
		UpdateFileList();
	}
}

void CRollerDlg::OnSelChangeFileView() 
{
	if(m_wndView.m_pCurrent != NULL)
	{
		CImageA * pImg;
		POSITION pos = m_wndView.m_pCurrent->m_plImages.GetHeadPosition();
		while(pos != NULL)
		{
			pImg = m_wndView.m_pCurrent->m_plImages.GetNext(pos);
			pImg->m_Enabled = (m_FileList.GetCheck(pImg->m_CtrlIndex) == 1)?true: false;
		}
	}
}

void CRollerDlg::OnDblClkFileView()
{
	if(m_wndView.m_pCurrent != NULL)
	{
		m_pImgClickOn = GetItem();
		if(m_pImgClickOn != NULL)
		{
			if(m_wndView.m_pCurrent->m_Type == CRegionA::RT_ANIMATED)
				SendMessage(WM_COMMAND, IDC_EDIT_DURATION);
			else if(m_pImgClickOn->m_pDesc->m_Empty)
				SendMessage(WM_COMMAND, IDC_EDIT_EMPTY);
		}
	}
}

void CRollerDlg::OnSelchangePrecisionCombo() 
{
	if(m_wndView.m_pCurrent != NULL)
	{
		m_wndView.m_pCurrent->m_Precision = static_cast<CComboBox*>(GetDlgItem(IDC_PRECISION_COMBO))->GetCurSel();
	}
}

void CRollerDlg::OnChangeRepeatCounter() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	if(m_wndView.m_pCurrent != NULL)
	{
		CString str;
		CEdit* pEdit = static_cast<CEdit*>(GetDlgItem(IDC_REPEAT_COUNTER));
		ASSERT(pEdit);
		pEdit->GetWindowText(str);
		if(str != "")
		{
			int rep;
			sscanf(str, "%d", &rep);
			if(rep > 1500)
				rep = 1500;
			else if(rep < 1)
				rep = 1;
			m_wndView.m_pCurrent->m_cRepeat = rep;
		}
	}
}

void CRollerDlg::OnSelchangeBank() 
{
	g_DefaultBank = static_cast<CComboBox*>(GetDlgItem(IDC_BANK))->GetCurSel();
}

void CRollerDlg::OnEditDuration() 
{
	ASSERT(m_pImgClickOn);
	CDurationDlg dlg;
	dlg.m_Duration = m_pImgClickOn->m_cDuration;
	dlg.m_Infinite = m_pImgClickOn->m_cDuration == -1;
	if(dlg.DoModal() == IDOK)
	{
		if(dlg.m_Infinite)
			m_pImgClickOn->m_cDuration = -1;
		else
			m_pImgClickOn->m_cDuration = dlg.m_Duration;
		UpdateFileList();
	}
}

void CRollerDlg::OnPause() 
{
	PausePlayback(m_hScreen);
}

void CRollerDlg::OnContinue() 
{
	ContinuePlayback(m_hScreen);
}
