//////////////////////////////////////////////////////////////////////////////////
//																				//
//		Roller																	//
//		Test and Demo of RollAPI library										//
//		Copyright (C),1998 SoftLab-Nsk											//
//																				//
//		Author:		Serge Horun													//
//																				//
//		Last revised(86C):		Dec 25, 1998, Serge Horun						//
//																				//
//////////////////////////////////////////////////////////////////////////////////

// RollerDlg.h : header file
//

#if !defined(AFX_ROLLERDLG_H__6B28554D_8857_11D2_9E24_00804883698B__INCLUDED_)
#define AFX_ROLLERDLG_H__6B28554D_8857_11D2_9E24_00804883698B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CRollerDlgAutoProxy;
class CViewA;

/////////////////////////////////////////////////////////////////////////////
// CRollerDlg dialog

class CRollerDlg : public CDialog
{
	DECLARE_DYNAMIC(CRollerDlg);
	friend class CRollerDlgAutoProxy;

// Construction
public:
	void UpdateFileList();
	void UpdateSpeedInfo();
	CRollerDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CRollerDlg();

// Dialog Data
	//{{AFX_DATA(CRollerDlg)
	enum { IDD = IDD_ROLLER_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRollerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CRect m_rcView;
	CRollerDlgAutoProxy* m_pAutoProxy;
	HICON m_hIcon;
	CCheckListBox m_FileList;
	CViewA m_wndView;
	bool m_Modified;
	CMenu m_Menu;
	ScreenHandle m_hScreen;
	CImageA * m_pImgClickOn;

	CImageA * GetItem();
	BOOL CanExit();

	// Generated message map functions
	//{{AFX_MSG(CRollerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnUpdateRegInfo();
	afx_msg void OnRadioClicked();
	afx_msg void OnSelchangeSpeedEdit();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnParentNotify(UINT message, LPARAM lParam);
	afx_msg void OnAddFile();
	afx_msg void OnPlay();
	afx_msg void OnStop();
	afx_msg void OnRemoveFile();
	afx_msg void OnImageNameClicked(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnMoveUp();
	afx_msg void OnMoveDown();
	afx_msg void OnAddEmpty();
	afx_msg void OnEditEmpty();
	afx_msg void OnSelChangeFileView();
	afx_msg void OnDblClkFileView();
	afx_msg void OnSelchangePrecisionCombo();
	afx_msg void OnChangeRepeatCounter();
	afx_msg void OnSelchangeBank();
	afx_msg void OnEditDuration();
	afx_msg void OnPause();
	afx_msg void OnContinue();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROLLERDLG_H__6B28554D_8857_11D2_9E24_00804883698B__INCLUDED_)
